%% The script performs an EWOk compression, followed by the positioning evaluation using k-NN algorithm.
% by Lucie Klus

close all; clear all;

addpath('databases');
addpath('functions')

%% Set parameters

K_NN = 1; % for k-NN
K_means = 8;
dataset = 'TUT2'; % select dataset (datasets in appropriate format are available at e.g. https://doi.org/10.5281/zenodo.3968503)
datarepresentation = 'positive'; % select data prepresentation
distance_metric = 'distance_cityblock'; % select k-NN distance metric

kmeans_init = 'max'; % select the k-means intialization method
kmeans_distance = 'cityblock'; % select the k-means distance metric

%% load the dataset

load(['databases/',dataset,'.mat']);
    fprintf(['Current dataset: ',dataset,'\n'])

%% evaluate the script

zero_value = min([database.trainingMacs(:);database.testMacs(:)]) - 1;
[results] = EWOk_knn(database , K_NN, datarepresentation, 100, ...
                    zero_value , distance_metric, K_means, kmeans_distance, kmeans_init);
